#include <bits/stdc++.h>
#define endl "\n"
using namespace std;

int ans[100005];
bool imaLi[100005];

vector<int>g[100005];

void dfs(int now){
    for(int i=0;i<g[now].size();i++){
            dfs(g[now][i]);
    }

    for(int i=0;i<g[now].size();i++){
            ans[now]+=ans[g[now][i]];
    }
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n,a,b;
    cin>>n;
    for(int i=0;i<n-1;i++){
        cin>>a>>b;
        ans[i]=1;
        a--;b--;
        g[a].push_back(b);
        imaLi[b]=true;
    }
    ans[n-1]=1;

    for(int i=0;i<n;i++){
        if(imaLi[i]==false){
            dfs(i);
            break;
        }
    }
    //for(int i=0;i<n;i++)cout<<ans[i]<<endl;
    cin>>n;
    for(int i=0;i<n;i++){
        cin>>a;
        a--;
        cout<<ans[a]-1<<endl;
    }

    return 0;
}
